//ShelbyWorks Graphics Library V1.0
//Graphic.h

#include <stdio.h>

#include <conio.h>

#include <stdlib.h>

#include <dos.h>

#include <mem.h>

#include <math.h>

#include <string.h>

#define sgn(x) ((x<0)?-1:((x>0)?1:0)) /* macro to return the sign of a
					 number */

/* macro to skip bytes in a file */
#define fskip(fp,n)   \
{                     \
   int i;             \
                      \
   for (i=0;i<n;i++)  \
      fgetc(fp);      \
}

typedef unsigned char  byte;
typedef unsigned short word;
typedef long           fixed16_16;
typedef unsigned long  dword;

//Circle
fixed16_16 SIN_ACOS[1024];

word VID = 0;


//for line draw alogorthim
byte *VGA=(byte *)0xA0000000L;        /* this points to video memory. */
byte *screen=(byte *)0xA0000000L;        /* this points to video memory. */

void SineTable()
{
word i;
for(i=0;i<1024;i++)                 /* create the sin(arccos(x)) table. */
  {
    SIN_ACOS[i]=sin(acos((float)i/1024))*0x10000L;
  }
  }

// maximum screen width
int getmaxx(void)

  {
    if (VID == 1)
    return 639;
    if (VID == 2)
    return 319;
   else
   return  0;
  }

//maximum screen hieght
int getmaxy(void)

  {

    if(VID == 1)
    return 479;
    if (VID == 2)
    return 199;
    else
    return 0;
  }

  //maximum  mumber of colors
int getmaxcolor(void)

  {

    return 255;

  }

//sets screen to 320*200*250 VGA/EGA
void SetVGA()
{

VID = 2;

  union REGS regs;

  regs.h.ah = 0x00;
  regs.h.al = 0x13;
  int86(0x10, &regs, &regs);
}

//sets screen to 640*480*250 SVGA
void SetSVGA(void)

  {
  VID = 1;

    asm mov ax,0x4f02;

    asm mov bx,0x101;

    asm int 0x10;

  }

// sets 80x25 Text mode
void SetTEXT(void)

  {
  VID = 0;

    asm mov ax,0x0003;

    asm int 0x10;

  }

//Put Pixel VGA
void VGAPixel (unsigned int x, unsigned int y, unsigned char c)
{
  VGA[(y << 8) + (y << 6) + x] = c;
}

//Put Pixel SVGA
void SVGAPixel (unsigned int x, unsigned int y, unsigned char c)
{
  VGA[y * 640 + x] = c;
}

// draws a line // Using Floating Point for Accuracy  //VGA ONLY
void drawline(float x1, float y1, float x2, float y2, byte color)
{
  int i,dx,dy,sdx,sdy,dxabs,dyabs,x,y,px,py;

  dx=x2-x1;      /* the horizontal distance of the line */
  dy=y2-y1;      /* the vertical distance of the line */
  dxabs=abs(dx);
  dyabs=abs(dy);
  sdx=sgn(dx);
  sdy=sgn(dy);
  x=dyabs>>1;
  y=dxabs>>1;
  px=x1;
  py=y1;

  VGA[py*320+px]=color;

  if (dxabs>=dyabs) /* the line is more horizontal than vertical */
  {
    for(i=0;i<dxabs;i++)
    {
      y+=dyabs;
      if (y>=dxabs)
      {
	y-=dxabs;
	py+=sdy;
      }
      px+=sdx;
      VGAPixel(px,py,color);
    }
  }
  else /* the line is more vertical than horizontal */
  {
    for(i=0;i<dyabs;i++)
    {
      x+=dxabs;
      if (x>=dyabs)
      {
	x-=dyabs;
	px+=sdx;
      }
      py+=sdy;
      VGAPixel(px,py,color);
    }
  }
}

//Draws Non-Filled Rectangle    SVGA ONLY
void Rect(int left,int top, int right, int bottom, byte color)
{
  word top_offset,bottom_offset,i,temp;

  if (top>bottom)
  {
    temp=top;
    top=bottom;
    bottom=temp;
  }
  if (left>right)
  {
    temp=left;
    left=right;
    right=temp;
  }

  top_offset=(top<<8)+(top<<6);
  bottom_offset=(bottom<<8)+(bottom<<6);

  for(i=left;i<=right;i++)
  {
    VGA[top_offset+i]=color;
    VGA[bottom_offset+i]=color;
  }
  for(i=top_offset;i<=bottom_offset;i+=640)
  {
    VGA[left+i]=color;
    VGA[right+i]=color;
  }
}

//Draws Filled in Rectangle SVGA ONLY
void SolidRect(int left,int top, int right, int bottom, byte color)
{
  word top_offset,bottom_offset,i,temp,width;

  if (top>bottom)
  {
    temp=top;
    top=bottom;
    bottom=temp;
  }
  if (left>right)
  {
    temp=left;
    left=right;
    right=temp;
  }

  top_offset=(top<<8)+(top<<6)+left;
  bottom_offset=(bottom<<8)+(bottom<<6)+left;
  width=right-left+1;

  for(i=top_offset;i<=bottom_offset;i+=640)
  {
    memset(&VGA[i],color,width);
  }
}

//Bitmap Viewer Begins Here*******************************

//Bitmap File Structure
typedef struct tagBITMAP              /* the structure for a bitmap. */
{
  word width;
  word height;
  byte *data;
} BITMAP;

//Bitmap Loader
void load_bmp(char *file,BITMAP *b)
{
  FILE *fp;
  long index;
  int x;
  int num_colors;

  /* open the file */
  if ((fp = fopen(file,"rb")) == NULL)
  {
    printf("Error opening file %s.\n",file);
    exit(1);
  }

  /* check to see if it is a valid bitmap file */
  if (fgetc(fp)!='B' || fgetc(fp)!='M')
  {
    fclose(fp);
    printf("%s is not a bitmap file.\n",file);
    exit(1);
  }

  /* read in the width and height of the image, and the
     number of colors used; ignore the rest */
  fskip(fp,16);
  fread(&b->width, sizeof(word), 1, fp);
  fskip(fp,2);
  fread(&b->height,sizeof(word), 1, fp);
  fskip(fp,22);
  fread(&num_colors,sizeof(word), 1, fp);
  fskip(fp,6);

  /* assume we are working with an 8-bit file */
  if (num_colors==0) num_colors=256;


  /* try to allocate memory */
  if ((b->data = (byte *) malloc((word)(b->width*b->height))) == NULL)
  {
    fclose(fp);
    printf("Error allocating memory for file %s.\n",file);
    exit(1);
  }

  /* Ignore the palette information for now.
     See palette.c for code to read the palette info. */
  fskip(fp,num_colors*4);

  /* read the bitmap */
  for(index=(b->height-1)*b->width;index>=0;index-=b->width)
    for(x=0;x<b->width;x++)
      b->data[(word)index+x]=(byte)fgetc(fp);

  fclose(fp);
}

//Draws Bitmap  //TransParent  //SVGA ONLY
void draw_bmp(BITMAP *bmp,int x,int y)
{
  int i,j;
  word screen_offset = y * 640;
  word bitmap_offset = 0;
  byte data;

  for(j=0;j<bmp->height;j++)
  {
    for(i=0;i<bmp->width;i++,bitmap_offset++)
    {
      data = bmp->data[bitmap_offset];
      if (data) VGA[screen_offset+x+i] = data;
    }
    screen_offset+=640;
  }
}

void VGA_bmp(BITMAP *bmp,int x,int y)
{
  int i,j;
  word screen_offset = y * 320;
  word bitmap_offset = 0;
  byte data;

  for(j=0;j<bmp->height;j++)
  {
    for(i=0;i<bmp->width;i++,bitmap_offset++)
    {
      data = bmp->data[bitmap_offset];
      if (data) VGA[screen_offset+x+i] = data;
    }
    screen_offset+=320;
  }
}
//Ends Here*******************************

//Graphics Interchange Format (.GIF) 87a and 89a Veiwer
typedef
  struct GIFHeader {
    char          Signature [7];
    unsigned int  ScreenWidth, ScreenHeight;
    unsigned char Depth, Background, Zero;
  };
  struct GIFDescriptor {
    char          Separator;
    unsigned int  ImageLeft, ImageTop, ImageWidth, ImageHeight;
    unsigned char Depth;
  };

FILE                 *GIFFile;
  unsigned int         BPointer;
  unsigned char        Buffer [257];
  //GIF data is stored in blocks of a certain size
  unsigned char        BlockSize;
  //For loading the code
  unsigned char        CodeSize;
  char                 BitsIn;
  unsigned char        Temp;
  //Coordinates
  unsigned int         X, Y, tlX, tlY, brX, brY;
  //The string table
  unsigned int         Prefix [4096];
  unsigned char        Suffix [4096];

 void SetDAC(unsigned char DAC, unsigned char R, unsigned char G, unsigned char B)
{
  outportb (0x3C8, DAC);
  outportb (0x3C9, R);
  outportb (0x3C9, G);
  outportb (0x3C9, B);
}

unsigned char LoadByte ()
{
  //Read next block}
  if (BPointer == BlockSize) {
    fread (Buffer, BlockSize + 1, 1, GIFFile);
    BPointer = 0;
  }

  //Return byte
  return Buffer [BPointer++];
}

//Procedure to read the next code from the file
unsigned int ReadCode ()
{
  int           Counter;
  unsigned int  Code;

  Code = 0;
  //Read the code, bit by bit
  for (Counter = 0; Counter < CodeSize; Counter++) {
    //Maybe, a new byte needs to be loaded with a further 8 bits
    if (++BitsIn == 9) {
      Temp = LoadByte ();
      BitsIn = 1;
    }

    //Add the current bit to the code
    if (Temp & 1) Code += 1 << Counter;
    Temp >>= 1;
  }
  return Code;
}

//Procedure to draw a pixel
void NextVGA (unsigned int c)
{
  //Actually draw the pixel on screen
  VGAPixel (X, Y, c & 255);

  //Move to next row, if necessary
  if (++X == brX) {
    X = tlX;
    Y++;
  }
}

void NextSVGA (unsigned int c)
{
  //Actually draw the pixel on screen
  SVGAPixel (X, Y, c & 255);

  //Move to next row, if necessary
  if (++X == brX) {
    X = tlX;
    Y++;
  }
}

//Local function to output a string. Returns the first character.
unsigned char OutString (unsigned int CurCode)
{
  unsigned int  OutCount;
  unsigned char OutCode [1024];

  //If it's a single character, output that
  if (CurCode < 256) {
    NextVGA (CurCode);
  } else {
    OutCount = 0;

    //Store the string, which ends up in reverse order
    do {
      OutCode [OutCount++] = Suffix [CurCode];
      CurCode = Prefix [CurCode];
    } while (CurCode > 255);

    //Add the last character
    OutCode [OutCount++] = CurCode;

    //Output all the string, in the correct order
    do {
      NextVGA (OutCode [--OutCount]);
    } while (OutCount);
  }
  //Return 1st character
  return CurCode;
}

//This actually loads the GIF
void VGA_GIF (char *Filename)
{
  //For loading from the GIF file
  struct GIFHeader     Header;
  struct GIFDescriptor Descriptor;

  //Colour information
  unsigned char        BitsPerPixel,
		       NumOfColours;
  unsigned int         DAC;
  unsigned char        Palette [256][3];

  //For indexing the string table
  unsigned int         FirstFree, FreeCode;

  //All the code information
  unsigned char        InitCodeSize;
  unsigned int         Code, OldCode, MaxCode;

  //Special codes
  unsigned int         ClearCode, EOICode;

  //Check whether the GIF file exists, and open it
  GIFFile = fopen (Filename, "rb");
  if (GIFFile == 0) {
    SetTEXT ();
    printf ("Could not open file %s", Filename);
    return;
  }

  //Read header
  fread (&Header, 6, 1, GIFFile);
  Header.Signature [6] = 0;
  fread (&Header.ScreenWidth, sizeof (Header) - 7, 1, GIFFile);

  //Check signature and terminator
  if ((strcmp (Header.Signature, "GIF87a")
    && strcmp (Header.Signature, "GIF89a"))
    || Header.Zero) {
    SetTEXT ();
    printf ("Not a valid GIF file\n");
    return;
  }

  //Get amount of colours in image
  BitsPerPixel = 1 + (Header.Depth & 7);
  NumOfColours = (1 << BitsPerPixel) - 1;

  //Load global colour map
  fread (Palette, 3, (NumOfColours + 1), GIFFile);
  for (DAC = 0; DAC <= NumOfColours; DAC++)
    SetDAC (DAC, Palette [DAC][0] >> 2,
		 Palette [DAC][1] >> 2,
		 Palette [DAC][2] >> 2);

  //Load the image descriptor
  fread (&Descriptor, sizeof (Descriptor), 1, GIFFile);

  if (Descriptor.Separator != ',') {
    SetTEXT ();
    printf ("Incorrect image descriptor.\n");
    return;
  }

  //Get image corner coordinates
  tlX = Descriptor.ImageLeft;
  tlY = Descriptor.ImageTop;
  brX = tlX + Descriptor.ImageWidth;
  brY = tlY + Descriptor.ImageHeight;

  //Some restrictions apply
  if (Descriptor.Depth & 128) {
    SetTEXT ();
    printf ("Local colour maps not supported\n");
    return;
  }
  if (Descriptor.Depth & 64) {
    SetTEXT ();
    printf ("Interlaced images not supported\n");
    return;
  }

  //Get initial code size
  fread (&CodeSize, 1, 1, GIFFile);

  //GIF data is stored in blocks, so it's necessary to know the size
  fread (&BlockSize, 1, 1, GIFFile);

  //Start loader
  BPointer = BlockSize;

  //Special codes used in the GIF spec
  ClearCode        = 1 << CodeSize;     //Code to reset
  EOICode          = ClearCode + 1;     //End of file

  //Initialize the string table
  FirstFree        = ClearCode + 2;     //Strings start here
  FreeCode         = FirstFree;         //Strings can be added here

  //Initial size of the code and its maximum value
  InitCodeSize     = ++CodeSize;
  MaxCode          = 1 << CodeSize;

  BitsIn = 8;

  //Start at top left of image
  X = Descriptor.ImageLeft;
  Y = Descriptor.ImageTop;

  do {
    //Read next code
    Code = ReadCode ();

    //If it's an End-Of-Information code, stop processing
	 if (Code == EOICode) break;
    //If it's a clear code...
    else if (Code == ClearCode) {
      //Clear the string table
      FreeCode = FirstFree;

      //Set the code size to initial values
      CodeSize = InitCodeSize;
      MaxCode  = 1 << CodeSize;

      //The next code may be read
      Code = ReadCode ();
      OldCode = Code;

      //Set pixel
      NextVGA (Code);
    //Other codes
    } else {
      /*If the code is already in the string table, it's string is displayed,
      and the old string followed by the new string's first character is
      added to the string table.*/
      if (Code < FreeCode)
	Suffix [FreeCode] = OutString (Code);
      else {
      /*If it is not already in the string table, the old string followed by
      the old string's first character is added to the string table and
      displayed.*/
	Suffix [FreeCode] = OutString (OldCode);
	NextVGA (Suffix [FreeCode]);
      }

      //Finish adding to string table
      Prefix [FreeCode++] = OldCode;

      //If the code size needs to be adjusted, do so
      if (FreeCode >= MaxCode && CodeSize < 12) {
	CodeSize++;
	MaxCode <<= 1;
      }

      //The current code is now old
      OldCode = Code;
    }
  } while (Code != EOICode);

  //Close the GIF file
  fclose (GIFFile);
}


//Problem See Note at bottom or Readme File
void SVGA_GIF (char *Filename)
{
  //For loading from the GIF file
  struct GIFHeader     Header;
  struct GIFDescriptor Descriptor;

  //Colour information
  unsigned char        BitsPerPixel,
		       NumOfColours;
  unsigned int         DAC;
  unsigned char        Palette [256][3];

  //For indexing the string table
  unsigned int         FirstFree, FreeCode;

  //All the code information
  unsigned char        InitCodeSize;
  unsigned int         Code, OldCode, MaxCode;

  //Special codes
  unsigned int         ClearCode, EOICode;

  //Check whether the GIF file exists, and open it
  GIFFile = fopen (Filename, "rb");
  if (GIFFile == 0) {
    SetTEXT ();
    printf ("Could not open file %s", Filename);
    return;
  }

  //Read header
  fread (&Header, 6, 1, GIFFile);
  Header.Signature [6] = 0;
  fread (&Header.ScreenWidth, sizeof (Header) - 7, 1, GIFFile);

  //Check signature and terminator
  if ((strcmp (Header.Signature, "GIF87a")
    && strcmp (Header.Signature, "GIF89a"))
    || Header.Zero) {
    SetTEXT ();
    printf ("Not a valid GIF file\n");
    return;
  }

  //Get amount of colours in image
  BitsPerPixel = 1 + (Header.Depth & 7);
  NumOfColours = (1 << BitsPerPixel) - 1;

  //Load global colour map
  fread (Palette, 3, (NumOfColours + 1), GIFFile);
  for (DAC = 0; DAC <= NumOfColours; DAC++)
    SetDAC (DAC, Palette [DAC][0] >> 2,
		 Palette [DAC][1] >> 2,
		 Palette [DAC][2] >> 2);

  //Load the image descriptor
  fread (&Descriptor, sizeof (Descriptor), 1, GIFFile);

  if (Descriptor.Separator != ',') {
    SetTEXT ();
    printf ("Incorrect image descriptor.\n");
    return;
  }

  //Get image corner coordinates
  tlX = Descriptor.ImageLeft;
  tlY = Descriptor.ImageTop;
  brX = tlX + Descriptor.ImageWidth;
  brY = tlY + Descriptor.ImageHeight;

  //Some restrictions apply
  if (Descriptor.Depth & 128) {
    SetTEXT ();
    printf ("Local colour maps not supported\n");
    return;
  }
  if (Descriptor.Depth & 64) {
    SetTEXT ();
    printf ("Interlaced images not supported\n");
    return;
  }

  //Get initial code size
  fread (&CodeSize, 1, 1, GIFFile);

  //GIF data is stored in blocks, so it's necessary to know the size
  fread (&BlockSize, 1, 1, GIFFile);

  //Start loader
  BPointer = BlockSize;

  //Special codes used in the GIF spec
  ClearCode        = 1 << CodeSize;     //Code to reset
  EOICode          = ClearCode + 1;     //End of file

  //Initialize the string table
  FirstFree        = ClearCode + 2;     //Strings start here
  FreeCode         = FirstFree;         //Strings can be added here

  //Initial size of the code and its maximum value
  InitCodeSize     = ++CodeSize;
  MaxCode          = 1 << CodeSize;

  BitsIn = 8;

  //Start at top left of image
  X = Descriptor.ImageLeft;
  Y = Descriptor.ImageTop;

  do {
    //Read next code
    Code = ReadCode ();

    //If it's an End-Of-Information code, stop processing
	 if (Code == EOICode) break;
    //If it's a clear code...
    else if (Code == ClearCode) {
      //Clear the string table
      FreeCode = FirstFree;

      //Set the code size to initial values
      CodeSize = InitCodeSize;
      MaxCode  = 1 << CodeSize;

      //The next code may be read
      Code = ReadCode ();
      OldCode = Code;

      //Set pixel
      NextSVGA (Code);
    //Other codes
    } else {
      /*If the code is already in the string table, it's string is displayed,
      and the old string followed by the new string's first character is
      added to the string table.*/
      if (Code < FreeCode)
	Suffix [FreeCode] = OutString (Code);
      else {
      /*If it is not already in the string table, the old string followed by
      the old string's first character is added to the string table and
      displayed.*/
	Suffix [FreeCode] = OutString (OldCode);
	NextSVGA (Suffix [FreeCode]);
      }

      //Finish adding to string table
      Prefix [FreeCode++] = OldCode;

      //If the code size needs to be adjusted, do so
      if (FreeCode >= MaxCode && CodeSize < 12) {
	CodeSize++;
	MaxCode <<= 1;
      }

      //The current code is now old
      OldCode = Code;
    }
  } while (Code != EOICode);

  //Close the GIF file
  fclose (GIFFile);
}
//Ends Here*******************************

//PaintBrush (.PCX) Graphics File Viewer     //VGA ONLY

void LoadPCX (char *FileName)
/*
  This loads in the actual PCX-file and displays it.
*/
{
   /*PCX Header structure*/
   struct PCXHeader {
     char Manufacturer, Version, Encoding, BitsPerPixel;
     int xMin, yMin, xMax, yMax;
     char Other[116];
   } Header;
   /*File handle*/
   FILE *PCXFile;
   /*Required for decoding and palette*/
   unsigned char DataByte, HowMany, Palette[256][3];
   int x, y, c;

   /*Check to see whether the file exists and can be opened*/
   PCXFile = fopen (FileName, "rb");
   if (PCXFile == NULL)  {
      strcat (FileName,".PCX");
      PCXFile = fopen (FileName, "rb");
      if (PCXFile == NULL) {
	printf ("Couldn't open file.");
	return;
      }
   }

   /*Read in header information*/
   fread (&Header, 128, 1, PCXFile);
   /*Check to see whether we can display it*/
   if (Header.Version != 5) {
     /*If other version than 5 don't display*/
     fclose (PCXFile);
     return;
   }
   if (Header.xMax>319 || Header.xMin<0 || Header.yMax>200 || Header.yMin<0) {
     /*If it doesn't fit on-screen, don't display*/
     fclose (PCXFile);
     return;
   }

   /*Load in the palette*/
   fseek (PCXFile, -769, SEEK_END);
   /*Read in identifier*/
   fread (&DataByte, 1, 1, PCXFile);
   if (DataByte!=12) {
     /*If there is no palette, don't display*/
   }

   fread (&Palette, 768, 1, PCXFile);
   for (c=0; c<255; c++) {
     SetDAC (c,Palette[c][0] >> 2, Palette[c][1] >> 2, Palette[c][2] >> 2);
   }

   /*Go back to start of graphic data*/
   fseek (PCXFile, 128, SEEK_SET);
   y=Header.yMin;
   x=Header.xMin;
   Header.xMax++;
   Header.yMax++;

   /*Decode and display graphics*/
   while (y<Header.yMax) {
      /*Read next byte*/
      fread (&DataByte, 1, 1, PCXFile);

      /*Reset counter*/
      HowMany=1;

      /*If it is encoded, extract the count information and read in the colour byte*/
      if ((DataByte & 0xC0)==0xC0) {
	HowMany = (DataByte & 0x3F);
	fread (&DataByte, 1, 1, PCXFile);
      }

      /*Display it*/
      for (c=1; c<=HowMany; c++) {
	/*Calculate on-screen offset, display Pixel and go to next pixel*/
	screen[(((y << 2) + y) << 6) + x++] = DataByte;
	/*If End of Line reached, next line*/
	if (x>=Header.xMax) {
	  y++; x=Header.xMin;
	}
      }
   }
   fclose (PCXFile);
}
//Ends Here******************************************

//Sets Pallate to Blue   //VGA & SVGA
void BluePalette ()
{
int DAC;
for (DAC = 1; DAC < 256; DAC++)
    SetDAC (DAC, DAC >> 3, DAC >> 3, 32 + (DAC >> 3));
}

//Sets Pallate to Red   //VGA & SVGA
void RedPalette ()
{
  int DAC;

  for (DAC = 1; DAC < 256; DAC++)
    SetDAC (DAC,32 + (DAC >> 3), DAC >> 3, DAC >> 3);
}

//Sets Pallate to Green   //VGA & SVGA
void GreenPalette ()
{
  int DAC;

  for (DAC = 1; DAC < 256; DAC++)
    SetDAC (DAC, DAC >> 3, 32 + (DAC >> 3), DAC >> 3);
}

//This rotates the palette     //VGA & SVGA
void RotatePal ()
{
  int DAC, OffSet;

  do {
    //Set up the new colours
    for (DAC = 0; DAC < 256; DAC++)
      //don't change colour 0 or the screen border would flash
      if ((DAC + OffSet) & 0xFF)
	SetDAC ((DAC + OffSet) & 0xFF, DAC >> 3, DAC >> 3, 32 + (DAC >> 3));
    OffSet++;
  } while (!kbhit());
}

//This makes a rain like pattern  //VGA ONLY!!!!! (for Now)
void MakeDrip ()
{
  unsigned int x, y, r, s;

  for (x = 0; x < 320; x++) {
    //For each column on screen, choose a different starting point...
      r = random (255) << 8;
      //...and speed
      s = (128 + random (128)) << 3;
       for (y = 0; y < 200; y++) {
      //Set each pixel on the column, don't use color 0
      if (!(r & 0xff00))
	VGAPixel (x, y, 1);
      else
	VGAPixel (x, y, r >> 8);
      //Move on to the next colour
      r += s;
    }
  }
}

void SVGA_circle(int x,int y, int radius, byte color)
{
SineTable();
  fixed16_16 n=0,invradius=(1/(float)radius)*0x10000L;
  int dx=0,dy=radius-1;
  word dxoffset,dyoffset,offset = (y*640)+x;

  while (dx<=dy)
  {
    dxoffset = (dx * 640);
    dyoffset = (dy * 640);
    VGA[offset+dy-dxoffset] = color;  /* octant 0 */
    VGA[offset+dx-dyoffset] = color;  /* octant 1 */
    VGA[offset-dx-dyoffset] = color;  /* octant 2 */
    VGA[offset-dy-dxoffset] = color;  /* octant 3 */
    VGA[offset-dy+dxoffset] = color;  /* octant 4 */
    VGA[offset-dx+dyoffset] = color;  /* octant 5 */
    VGA[offset+dx+dyoffset] = color;  /* octant 6 */
    VGA[offset+dy+dxoffset] = color;  /* octant 7 */
    dx++;
    n+=invradius;
    dy = (int)((radius * SIN_ACOS[(int)(n>>6)]) >> 16);
  }
}

void VGA_circle(int x,int y, int radius, byte color)
{
SineTable();
  fixed16_16 n=0,invradius=(1/(float)radius)*0x10000L;
  int dx=0,dy=radius-1;
  word dxoffset,dyoffset,offset = (y*320)+x;

  while (dx<=dy)
  {
    dxoffset = (dx * 320);
    dyoffset = (dy * 320);
    VGA[offset+dy-dxoffset] = color;  /* octant 0 */
    VGA[offset+dx-dyoffset] = color;  /* octant 1 */
    VGA[offset-dx-dyoffset] = color;  /* octant 2 */
    VGA[offset-dy-dxoffset] = color;  /* octant 3 */
    VGA[offset-dy+dxoffset] = color;  /* octant 4 */
    VGA[offset-dx+dyoffset] = color;  /* octant 5 */
    VGA[offset+dx+dyoffset] = color;  /* octant 6 */
    VGA[offset+dy+dxoffset] = color;  /* octant 7 */
    dx++;
    n+=invradius;
    dy = (int)((radius * SIN_ACOS[(int)(n>>6)]) >> 16);
  }
  }

void VGA_SolidCircle(int x,int y, int radius, byte color)
{
SineTable();
  fixed16_16 n=0,invradius=(1/(float)radius)*0x10000L;
  int dx=0,dy=radius-1,i;
  word dxoffset,dyoffset,offset = (y<<8)+(y<<6)+x;

  while (dx<=dy)
  {
    dxoffset = (dx<<8) + (dx<<6);
    dyoffset = (dy<<8) + (dy<<6);
    for(i=dy;i>=dx;i--,dyoffset-=320)
    {
      VGA[offset+i -dxoffset] = color;  /* octant 0 */
      VGA[offset+dx-dyoffset] = color;  /* octant 1 */
      VGA[offset-dx-dyoffset] = color;  /* octant 2 */
      VGA[offset-i -dxoffset] = color;  /* octant 3 */
      VGA[offset-i +dxoffset] = color;  /* octant 4 */
      VGA[offset-dx+dyoffset] = color;  /* octant 5 */
      VGA[offset+dx+dyoffset] = color;  /* octant 6 */
      VGA[offset+i +dxoffset] = color;  /* octant 7 */
    }
    dx++;
    n+=invradius;
    dy = (int)((radius * SIN_ACOS[(int)(n>>6)]) >> 16);
  }
}

void SVGA_SolidCircle(int x,int y, int radius, byte color)
{
SineTable();
  fixed16_16 n=0,invradius=(1/(float)radius)*0x10000L;
  int dx=0,dy=radius-1,i;
  word dxoffset,dyoffset,offset = (y*640)+x;

  while (dx<=dy)
  {
    dxoffset = (dx*640);
    dyoffset = (dy*640);
    for(i=dy;i>=dx;i--,dyoffset-=640)  //320 Looks Fat!!!!
    {
      VGA[offset+i -dxoffset] = color;  /* octant 0 */
      VGA[offset+dx-dyoffset] = color;  /* octant 1 */
      VGA[offset-dx-dyoffset] = color;  /* octant 2 */
      VGA[offset-i -dxoffset] = color;  /* octant 3 */
      VGA[offset-i +dxoffset] = color;  /* octant 4 */
      VGA[offset-dx+dyoffset] = color;  /* octant 5 */
      VGA[offset+dx+dyoffset] = color;  /* octant 6 */
      VGA[offset+i +dxoffset] = color;  /* octant 7 */
    }
    dx++;
    n+=invradius;
    dy = (int)((radius * SIN_ACOS[(int)(n>>6)]) >> 16);
  }
}





//MOST "//" style comments are mine
// all "/*" style comments were added from pieces of code added from other people

//SVGA_GIF Function draws 2 pictures!?! I can't figure out why. If you can please
//let me know thug_death@hotmail.com.

//Copyright(c) 1998 ShelbyWorks Software
// All alorthims property of the respective owners

//Borland C++3.1+; Watcom C/C++; Microsoft C; Symantec C++
// NOT tested or approved for djgpp, Intel C/C++, or GNU gcc(Linux/Unix)
